% images Matlab 
% 2d signaly - obrazky 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

x = imread('fig/lena_cb.tif'); x = double(x) / 256; 
subplot(121); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; 
 vert=148:162; hor=114:128; 
 h=rectangle('Position',[hor(1)-0.5,vert(1)-0.5,hor(end)-hor(1)+1,vert(end)-vert(1)+1], 'EdgeColor','red'); 
 subplot(122); image(x(vert,hor),'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image;  
 print -dpng fig/lena_basic.png 
 
% include colorbar 
close all; 
image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; 
colorbar 
print -dpng fig/lena_basic+bar.png 

%%% operace nad pixely - jas 
y = x + 0.2; 
subplot(121); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; 
subplot(122); image(y,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; 
print -dpng fig/jas_plus.png 

y = x - 0.2; 
subplot(121); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; 
subplot(122); image(y,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; 
print -dpng fig/jas_minus.png 

%%% operace nad pixely - kontrast
y = x * 1.2; 
subplot(121); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; 
subplot(122); image(y,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; 
print -dpng fig/kontrast_plus.png 

y = x * 0.5; 
subplot(121); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; 
subplot(122); image(y,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; 
print -dpng fig/kontrast_minus.png 

%%% histograms ... 
close all; 
imhist(x); print -dpng fig/hist.png 

%%% hist equalization 
subplot(221); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; 
subplot(223); imhist(x);
y= histeq(x); 
subplot(222); image(y,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; 
subplot(224); imhist(y);
  print -dpng fig/hist_eq.png 

%%% thresholding 
subplot(221); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; 
subplot(223); imhist(x);
y = (x>0.45); % condition ... 
subplot(222); image(y,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; 
subplot(224); imhist(y);
  print -dpng fig/black_white.png 

%%%%%%%%%% ok, now the filtering 
h = [1]; % wire ... 
y = filter2(h,x); 
close all; 
subplot(121); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; 
subplot(122); image(y,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; 
print -dpng fig/wire.png 
  
%%% low pass 
subplot(221); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; 
 vert=148:162; hor=114:128; 
 h=rectangle('Position',[hor(1)-0.5,vert(1)-0.5,hor(end)-hor(1)+1,vert(end)-vert(1)+1], 'EdgeColor','red'); 
 subplot(223); image(x(vert,hor),'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image;  
y = filter2(ones(3,3)*1/9, x); 
subplot(222); image(y,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; 
 vert=148:162; hor=114:128; 
 h=rectangle('Position',[hor(1)-0.5,vert(1)-0.5,hor(end)-hor(1)+1,vert(end)-vert(1)+1], 'EdgeColor','red'); 
 subplot(224); image(y(vert,hor),'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image;  
  print -dpng fig/low+detail.png 

% SObel vertical edges - going to use the blue/red scale ! 
BLUERED = zeros(101,3); % red  / green / blue
gg = linspace(0,1,51)';
BLUERED(51:101,1) = gg; % red one
BLUERED(51:-1:1,3) = gg; % blue one

close all; 
subplot(121); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; freezeColors; 
h = [1 0 -1; 2 0 -2; 1 0 -1];
yvert = filter2(h/8, x); 
subplot(122); image(yvert,'CDataMapping','scaled'); colormap(BLUERED); caxis([-0.2 0.2]); axis image; 
  print -dpng fig/vertical_blue_red.png 

% what to do ?? 
% abs value 
y = abs(yvert); 
close all; 
subplot(121); image(yvert,'CDataMapping','scaled'); colormap(BLUERED); caxis([-0.2 0.2]); axis image; freezeColors; 
subplot(122); image(y,'CDataMapping','scaled'); colormap('gray'); caxis([0 0.2]); axis image; 
  print -dpng fig/abs_valued.png 

% SObel horizontal one  - going to use the blue/red scale ! 
close all; 
subplot(121); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; freezeColors; 
h =[1 0 -1; 2 0 -2; 1 0 -1]';
yhor = filter2(h/8, x); 
subplot(122); image(yhor,'CDataMapping','scaled'); colormap(BLUERED); caxis([-0.2 0.2]); axis image; 
  print -dpng fig/horizontal_blue_red.png 
  
% both together in abs value ... 
y = abs(yvert) + abs(yhor); 
close all; 
image(yhor,'CDataMapping','scaled'); colormap(gray); caxis([0 0.1]); axis image; 
  print -dpng fig/vert+hor_abs.png 
  
%%% noised image with sharp edges ... low-pass filter 
xsn = zeros(512,512); xsn(100:200,100:200) = 1; xsn = xsn + randn(512,512) * 0.4; 
close all; 
subplot(121); image(xsn,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image;  
h = ones(9,9) / 81; 
y = filter2(h,xsn); 
subplot(122); image(y,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; 
  print -dpng fig/noise_low_pass.png 

% median one 
close all; 
subplot(121); image(xsn,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image;  
y = medfilt2(xsn, [9 9]); 
subplot(122); image(y,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; 
  print -dpng fig/noise_median.png 

%%%%%%%%%%%%%%%%%%%% 2d DF %%%%%%%%%%%%%%%%%%%%%%%
% examples 1 D ... 
s = wavread('../02_spectrum/sig/signal.wav'); 
x = s(1:100); 
  subplot(211); stem(x);
  subplot(212); plot(x); 
  print -dpng fig/1d.png 

% baze 1D 
n=0:99; 
X = zeros(6,100); 
for ii=1:6; 
  x = cos(2*pi*(ii-1)/ 100 * n); 
  X(ii,:) = x; 
end
plot (n,X); 
  print -dpng fig/coses_1d.png 

% baze complex exp ... 
f = 1/100; 
k = 3; 
ce = exp(-j *2 *pi * f * k * n); 
close all; 
subplot (311); plot3(n,real(ce),imag(ce)); 
subplot (312); plot(n,real(ce));
subplot (313); plot(n,imag(ce)); pause
  print -dpng fig/expj_1d.png 

%%%%%%% DEMO 4 cos a siny ... %%%%%%%%%%%%%
n = 0:99; 
a = cos(3* 2*pi*n/100);
b = -sin(3* 2*pi*n/100);
phi = -0.75*pi; 
  x =  cos(3* 2*pi*n/100 + phi);  
  subplot(321); plot(n,x); title('x[n]'); grid;
  %cos
  subplot(323); plot(n,a,'r'); title('a[n]'); grid;
  xa = x.*a; 
  subplot(325); plot(n,xa); title('x[n] a[n]'); grid;
  c = sum (xa); text(75,mean(xa),['c = ' num2str(c)],'FontSize',15); 
  % sin
  subplot(324); plot(n,b,'r'); title('b[n]'); grid;
  xb = x.*b; 
  subplot(326); plot(n,xb); title('x[n] b[n]'); grid;
  d = sum (xb); %text(75,mean(xb),['\Sigma = ' num2str(d)],'FontSize',30); 
  e = sqrt(c ^2 + d^2); text(10,mean(xb),['d = ' num2str(d) ' (c^2 + d^2)^{-1/2}=' num2str(e)],'FontSize',15); 
print -dpng fig/exp_1d_anal1.png 

phi = 1.66*pi; 
  x =  cos(3* 2*pi*n/100 + phi);  
  subplot(321); plot(n,x); title('x[n]'); grid;
  %cos
  subplot(323); plot(n,a,'r'); title('a[n]'); grid;
  xa = x.*a; 
  subplot(325); plot(n,xa); title('x[n] a[n]'); grid;
  c = sum (xa); text(75,mean(xa),['c = ' num2str(c)],'FontSize',15); 
  % sin
  subplot(324); plot(n,b,'r'); title('b[n]'); grid;
  xb = x.*b; 
  subplot(326); plot(n,xb); title('x[n] b[n]'); grid;
  d = sum (xb); %text(75,mean(xb),['\Sigma = ' num2str(d)],'FontSize',30); 
  e = sqrt(c ^2 + d^2); text(10,mean(xb),['d = ' num2str(d) ' (c^2 + d^2)^{-1/2}=' num2str(e)],'FontSize',15); 
print -dpng fig/exp_1d_anal2.png 
  
  
  
%%% now the 2D thing ... 
a = ones(100,100); 
lena = imread('fig/lena_100.tif'); lena = double(lena) / 256; 
x = lena; 
subplot(331); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; 
subplot(334); image(a,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; 
subplot(337); image(a.*x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; sum(sum(a.*x))
x = lena+0.2; 
subplot(332); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; 
subplot(335); image(a,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; 
subplot(338); image(a.*x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; sum(sum(a.*x))
x = lena+0.4; 
subplot(333); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; 
subplot(336); image(a,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; 
subplot(339); image(a.*x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image; sum(sum(a.*x))
  print -dpng fig/corel_dc.png 

   4.8287e+03
   6.8287e+03
   8.8287e+03

%%%%%%%% now horizontal cos ! 
K = 100; L = 100; k=0:K-1; l = 0:L-1; 
oneline = cos (2*pi*1/100 * k); 
a = ones(100,1) * oneline; % produces a matrix 
close all; 
image(a,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; colorbar; 
  print -dpng fig/horiz_cos_only_colorbar.png 

%%%% let's analyze different signals ... 
% d.c.
close all; 
x = ones(100,100); 
subplot(331); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image;freezeColors 
subplot(334); image(a,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
subplot(337); image(a.*x,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; sum(sum(a.*x))
% the same cos ... 
oneline = 0.5*cos (2*pi*1/100 * k) + 0.5; 
x = ones(100,1) * oneline; % produces a matrix 
subplot(332); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image;freezeColors 
subplot(335); image(a,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
subplot(338); image(a.*x,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; sum(sum(a.*x))
% 2 times faster  cos ... 
oneline = 0.5*cos (2*pi*2/100 * k) + 0.5; 
x = ones(100,1) * oneline; % produces a matrix 
subplot(333); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image;freezeColors 
subplot(336); image(a,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
subplot(339); image(a.*x,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; sum(sum(a.*x))

   4.5475e-13
        2500
   3.4106e-13

  print -dpng fig/horiz_cos_analysis.png 

%%% the same with 2 times faster cos as analysis ... 
oneline = cos (2*pi*2/100 * k); 
a = ones(100,1) * oneline; % produces a matrix 

close all; 
x = ones(100,100); 
subplot(331); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image;freezeColors 
subplot(334); image(a,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
subplot(337); image(a.*x,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; sum(sum(a.*x))
% the same cos ... 
oneline = 0.5*cos (2*pi*1/100 * k) + 0.5; 
x = ones(100,1) * oneline; % produces a matrix 
subplot(332); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image;freezeColors 
subplot(335); image(a,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
subplot(338); image(a.*x,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; sum(sum(a.*x))
% 2 times faster  cos ... 
oneline = 0.5*cos (2*pi*2/100 * k) + 0.5; 
x = ones(100,1) * oneline; % produces a matrix 
subplot(333); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image;freezeColors 
subplot(336); image(a,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
subplot(339); image(a.*x,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; sum(sum(a.*x))

  print -dpng fig/horiz_fastercos_analysis.png 
  
   2.9843e-13
    1.5064e-12
    2.5000e+03

%%%% anal signal vertically ... 
onecol = cos (2*pi*1/100 * l)'; 
a = onecol * ones(1,100); 

close all; 
x = ones(100,100); 
subplot(331); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image;freezeColors 
subplot(334); image(a,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
subplot(337); image(a.*x,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; sum(sum(a.*x))
% the same cos ... 
onecol = 0.5*cos (2*pi*1/100 * l)'+0.5; 
x = onecol * ones(1,100); 
subplot(332); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image;freezeColors 
subplot(335); image(a,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
subplot(338); image(a.*x,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; sum(sum(a.*x))
% 2 times faster  cos ... 
onecol = 0.5 * cos (2*pi*2/100 * l)'+ 0.5; 
x = onecol * ones(1,100); 
subplot(333); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image;freezeColors 
subplot(336); image(a,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
subplot(339); image(a.*x,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; sum(sum(a.*x))

  print -dpng fig/vert_cos_analysis.png 

  -7.7716e-14
   2.5000e+03
   6.9944e-13

%%% twice as fast vertically ... 
onecol = cos (2*pi*2/100 * l)'; 
a = onecol * ones(1,100); 

close all; 
x = ones(100,100); 
subplot(331); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image;freezeColors 
subplot(334); image(a,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
subplot(337); image(a.*x,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; sum(sum(a.*x))
% the same cos ... twice faster 
onecol = 0.5*cos (2*pi*2/100 * l)'+0.5; 
x = onecol * ones(1,100); 
subplot(332); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image;freezeColors 
subplot(335); image(a,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
subplot(338); image(a.*x,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; sum(sum(a.*x))
% something else ... 
x= lena; 
subplot(333); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image;freezeColors 
subplot(336); image(a,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
subplot(339); image(a.*x,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; sum(sum(a.*x))

  print -dpng fig/vert_fastercos_analysis.png 

   4.9960e-13
   2.5000e+03
  -65.4694

%%%%%%%%%%%%%%%%% changes in both directions ... 
oneline = cos (2*pi*3/100 * l); 
ahor = ones(100,1) * oneline; 
onecol = cos (2*pi*7/100 * k)'; 
aver = onecol * ones(1,100); 
a = ahor .* aver; 
% check that I did not screw up ... arguments oif the cosine ! 
myargs = ones(100,1) * (2*pi*3/100 * l) + (2*pi*7/100 * k)' * ones(1,100); 
acheck = cos(myargs); 
% the first method is WRONG ! 

close all ; 
subplot(131); image(ahor,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image;freezeColors 
subplot(132); image(aver,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
subplot(133); image(acheck,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
  print -dpng fig/horiz_vert_both.png 

%%%%%%%%%%% problem with phases ... 
%%% the same with 2 times faster cos as analysis ... 
oneline = cos (2*pi*2/100 * k); 
a = ones(100,1) * oneline; % produces a matrix 


% the same one ... 
close all; 
oneline = 0.5*cos (2*pi*2/100 * k) + 0.5; 
x = ones(100,1) * oneline; % produces a matrix 
subplot(331); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image;freezeColors 
subplot(334); image(a,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
subplot(337); image(a.*x,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; sum(sum(a.*x))
% the same cos but shifted 
oneline = 0.5*cos (2*pi*2/100 * k + pi/2) + 0.5; 
x = ones(100,1) * oneline; % produces a matrix 
subplot(332); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image;freezeColors 
subplot(335); image(a,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
subplot(338); image(a.*x,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; sum(sum(a.*x))
% again the same but shifted ... 
oneline = 0.5*cos (2*pi*2/100 * k - pi/2) + 0.5; 
x = ones(100,1) * oneline; % produces a matrix 
subplot(333); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image;freezeColors 
subplot(336); image(a,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
subplot(339); image(a.*x,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; sum(sum(a.*x))

  print -dpng fig/phase_bad.png 
  
     2.5000e+03
   9.9476e-13
  -5.6843e-14

%%----------------------- complex exponentials ---------------------
%%% d.c. the same as we had ... 

%%% visualize complex exps horizontally for X[0,1]
close all; hold on; axis([0 99 -1 23 -1 1]); 
l = 0:99; m = 0; n = 1; 
for k = 0:12; 
  ce = exp(-j *2 * pi * (n * l / 100)); 
  plot3(l,real(ce) + 2*k,imag(ce));   % 2*x is there for the visu ... 
end
hold off; 
% ... na prd, nakreslit rukou ... 

%%% 3 posunute cosinusovky ... prumet do cos a -sin ... 
k = 0:99; l=0:99; 
oneline = cos (2*pi*2/100 * k); 
acos = ones(100,1) * oneline; % produces a matrix 
oneline = -sin (2*pi*2/100 * k); 
asin = ones(100,1) * oneline; % produces a matrix 

% basic cos ... 
close all; 
oneline = 0.5*cos (2*pi*2/100 * k) + 0.5; 
x = ones(100,1) * oneline; % produces a matrix 
subplot(321); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image;freezeColors 
subplot(323); image(acos,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
subplot(325); image(acos.*x,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; rr = sum(sum(acos.*x))
subplot(324); image(asin,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
subplot(326); image(asin.*x,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; ii = sum(sum(asin.*x))
[rr ii abs(rr+j*ii) angle(rr+j*ii)]
% kontrola fft 
X = fft2(x); X(1,3)  % remember Matlab indexing ... 
  1.0e+03 *
      2.5000 0.0000   2.5000    0.0000
   2.5000e+03 + 6.9098e-13i
   
 print -dpng fig/cos_sin_anal1.png 
 
% something shifted ... 
close all; 
oneline = 0.5*cos (2*pi*2/100 * k - pi/3) + 0.5; 
x = ones(100,1) * oneline; % produces a matrix 
subplot(321); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image;freezeColors 
subplot(323); image(acos,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
subplot(325); image(acos.*x,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; rr = sum(sum(acos.*x))
subplot(324); image(asin,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
subplot(326); image(asin.*x,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; ii = sum(sum(asin.*x))
[rr ii abs(rr+j*ii) angle(rr+j*ii)]
% kontrola fft 
X = fft2(x); X(1,3)  % remember Matlab indexing ... 
  1.0e+03 *
    1.2500   -2.1651    2.5000   -0.0010
   1.2500e+03 - 2.1651e+03i

 print -dpng fig/cos_sin_anal2.png 

% and one more ... 
close all; 
oneline = 0.5*cos (2*pi*2/100 * k - 7*pi/5) + 0.5; 
x = ones(100,1) * oneline; % produces a matrix 
subplot(321); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image;freezeColors 
subplot(323); image(acos,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
subplot(325); image(acos.*x,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; rr = sum(sum(acos.*x))
subplot(324); image(asin,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
subplot(326); image(asin.*x,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; ii = sum(sum(asin.*x))
[rr ii abs(rr+j*ii) angle(rr+j*ii)]
% kontrola fft 
X = fft2(x); X(1,3)  % remember Matlab indexing ... 
  1.0e+03 *
   -0.7725    2.3776    2.5000    0.0019
  -7.7254e+02 + 2.3776e+03i

 print -dpng fig/cos_sin_anal3.png 

%%%%%%%%%%%%%% both directions ... 
myargs = ones(100,1) * (3/100 * l) + (7/100 * k)' * ones(1,100); 
a = exp(-j * 2 * pi * myargs); 

% non matched signal ... 
myargs = ones(100,1) * (2*pi*4/100 * l) + (2*pi*5/100 * k)' * ones(1,100); 
x = 0.5 * cos(myargs) + 0.5; 
close all 
subplot(321); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image;freezeColors 
acos = real(a); 
subplot(323); image(acos,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
subplot(325); image(acos.*x,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; rr = sum(sum(acos.*x))
asin = imag(a); 
subplot(324); image(asin,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
subplot(326); image(asin.*x,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; ii = sum(sum(asin.*x))
[rr ii abs(rr+j*ii) angle(rr+j*ii)]
% kontrola fft 
X = fft2(x); X(8,4)  % remember Matlab indexing ... 
   1.0e-03 *
    0.0000    0.0000    0.0000    0.3711
   6.7148e-15 + 1.0947e-13i

 print -dpng fig/X37_bad.png 

%% matching one with different phases ... 
myargs = ones(100,1) * (2*pi*3/100 * l + pi/2) + (2*pi*7/100 * k - pi/3)' * ones(1,100); 
x = 0.5 * cos(myargs) + 0.5; 
close all 
subplot(321); image(x,'CDataMapping','scaled'); colormap('gray'); caxis([0 1]); axis image;freezeColors 
acos = real(a); 
subplot(323); image(acos,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
subplot(325); image(acos.*x,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; rr = sum(sum(acos.*x))
asin = imag(a); 
subplot(324); image(asin,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
subplot(326); image(asin.*x,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; ii = sum(sum(asin.*x))
[rr ii abs(rr+j*ii) angle(rr+j*ii)]
% kontrola fft 
X = fft2(x); X(8,4)  % remember Matlab indexing ... 
  1.0e+03 *
    2.1651    1.2500    2.5000    0.0005
   2.1651e+03 + 1.2500e+03i

 print -dpng fig/X37_good.png 

%%%%%%%%%%%%%% the whole thing for Lena %%%%%%%%%%%%%%%%%%%%%%
% full Lena 512*512 pix
x = imread('fig/lena_cb.tif'); x = double(x) / 256; 
X = fft2(x); MAXX = max(max(abs(X(2:512,2:512))));  % has to exlude X[0,0] for visualization!!!
close all; 
image(x,'CDataMapping','scaled'); colormap(gray); caxis([0 1]); axis image; 
% plot this to separate ones, so that we can show the scale ! 
print -dpng fig/lena_full.png 

subplot(121); image(abs(X(1:257,1:257)),'CDataMapping','scaled'); colormap(gray); caxis([0 MAXX]); axis image; % tam skoro nic neni ! jeste zoom ... 
 vert=1:20; hor=1:20; 
 h=rectangle('Position',[hor(1)-0.5,vert(1)-0.5,hor(end)-hor(1)+1,vert(end)-vert(1)+1], 'EdgeColor','red'); 
 subplot(122); image(abs(X(vert,hor)),'CDataMapping','scaled'); colormap(gray); caxis([0 MAXX]); axis image; % tam skoro nic neni ! jeste zoom ... 
 print -dpng fig/lena_spec_zoom.png 

%%%%%%%%%%%%%  somesynthetic image ... 
x = zeros (512,512); 
% 50 randomly spaced white  squares ... 
xpos = round(rand(1,50) * 450 + 1); 
ypos = round(rand(1,50) * 450 + 1); 
size = round(rand(1,50) * 50 + 1); 
% make them ... 
for ii=1:50; 
  x(xpos(ii):xpos(ii)+size(ii),ypos(ii):ypos(ii)+size(ii)) = 1; 
end
% plus some high freq ... and limit to 0...1
k = 0:511; l=k; 
myargs = ones(512,1) * (2*pi*80/512 * l + pi/2) + (2*pi*157/512 * k - pi/3)' * ones(1,512);
x = x + 0.5 * cos(myargs); 
%x = x + randn(512,512)*0.5; 
x = max(x,zeros(512,512)); x=min(x,ones(512,512));
close all 
image(x,'CDataMapping','scaled'); colormap(gray); caxis([0 1]); axis image;  % nice. 
 print -dpng fig/art.png 

X = fft2(x); % scalibng by hand ... 
close all 
image(abs(X(1:257,1:257)),'CDataMapping','scaled'); colormap(gray); caxis([0 100]); axis image; 
 print -dpng fig/art_spec_small.png 

image(abs(X),'CDataMapping','scaled'); colormap(gray); caxis([0 100]); axis image; 
 print -dpng fig/art_spec_full.png 
  
%%% export  the 4 parts so that we can re-shuffle ... no - plot, will cut in Irfan... 
% 1st quadrant is art_spec_small.png  ... 
image(abs(X(1:257,258:512)),'CDataMapping','scaled'); colormap(gray); caxis([0 100]); axis image;  print -dpng fig/art_spec_small_2.png 
 
image(abs(X(258:512,1:257)),'CDataMapping','scaled'); colormap(gray); caxis([0 100]); axis image;  print -dpng fig/art_spec_small_3.png 

image(abs(X(258:512,258:512)),'CDataMapping','scaled'); colormap(gray); caxis([0 100]); axis image;  print -dpng fig/art_spec_small_4.png 

%%%%%%%%%%%%% some filtering and 2DiDFT ... 
x = imread('fig/lena_cb.tif'); x = double(x) / 256; 
X = fft2(x); 
image(abs(X),'CDataMapping','scaled'); colormap(gray); caxis([0 500]); axis image; 
 print -dpng fig/lena_spec_full.png 

% lets try to take just 50 points ... 
SPECMASK = zeros(512,512); N = 50; 
SPECMASK(1:N+1,1:N+1) = 1; 
SPECMASK(1:N+1,512-N+1:512) = 1; 
SPECMASK(512-N+1:512,1:N+1) = 1; 
SPECMASK(512-N+1:512,512-N+1:512) = 1; 
image(SPECMASK,'CDataMapping','scaled'); colormap(gray); caxis([0 1]); axis image; 

 print -dpng fig/specmask.png 

Y = X.*SPECMASK; 
image(abs(Y),'CDataMapping','scaled'); colormap(gray); caxis([0 500]); axis image; 
 print -dpng fig/lena_spec_masked.png 

y = ifft2(Y); % wow, it's real ! 
image(y,'CDataMapping','scaled'); colormap(gray); caxis([0 1]); axis image; 
 print -dpng fig/lena_lowpassed.png 

%%% the same for the art ... students to do .... 

%%%%%%%%%%%%%%%%%%%%%%% DCT %%%%%%%%%%%%%%%%%%%%%
% see definition of DCT II on wikipedia ..
A = zeros(100,100); N = 100; 
n = 0:N-1; 
for k=0:N-1,
  oneline = cos(pi / N * (n+1/2) * k); 
  A(k+1,:) = oneline; 
end
plot (n,A(1:6,:)); 
% compute it one some sample signal and make it coherent to Matlab ... 
x = randn(100,1); 
c = A * x; 
c(1) = c(1) * sqrt(1/N); 
c(2:100) = c(2:100) * sqrt(2/N); 

cmatlab = dct(x); 
c-cmatlab  
 ... OK, this works. 
 
plot (n,A(1:6,:)); print -dpng fig/dct_bases.png % + zoom
print -dpng fig/dct_bases_detail.png 

%%%% Lena a filtrovani v DCT domene ... 
x = imread('fig/lena_cb.tif'); x = double(x) / 256; 
X = dct2(x); 
image(X,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
 print -dpng fig/lena_dct_full.png 

DCTMASK = zeros(512,512); N = 50; 
DCTMASK(1:N+1,1:N+1) = 1; 
image(DCTMASK,'CDataMapping','scaled'); colormap(gray); caxis([0 1]); axis image; 
 print -dpng fig/dctmask.png 

Y = X.*DCTMASK; 
image(Y,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
 print -dpng fig/lena_dct_masked.png 

y = idct2(Y); % wow, it's real ! 
image(y,'CDataMapping','scaled'); colormap(gray); caxis([0 1]); axis image; 
 print -dpng fig/lena_dctlowpassed.png 


  









  
  
  



@@@

 



....

%%% ================= blue red colormap testing ============= 
colormap('gray'); GRAY = colormap; 
BLUERED = zeros(101,3); % red  / green / blue
gg = linspace(0,1,51)';
BLUERED(51:101,1) = gg; % red one
BLUERED(51:-1:1,3) = gg; % blue one

k = 0:99; oneline = cos (2*pi*1/100 * k); 
x = ones(100,1) * oneline; % produces a matrix 
subplot(121); imshow(x,[-1 1]); colormap(BLUERED); 
subplot(122); imshow(x,[-1 1]); colormap(gray); % grrrr do hajzlu, colormap se meni vsude !
subplot(121); image(x,'CDataMapping','scaled'); colormap(GRAY); caxis([0 1]); axis image;
subplot(122); image(x,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image; 
  %%% grr toto taky :( 
% subimage ? 
subplot(121); subimage(x,BLUERED); caxis(-[1 1]); axis image;
subplot(122); subimage(x,GRAY);  ; caxis([0 1]); axis image; 
% ... totalne na prd, budu to generovat jako single figures uaaaa . 

% printing ? 
figure(1); imshow(x,[-1 1]); colormap(BLUERED); print -dpng fig/test1.png
figure(2); imshow(x,[0 1]); colormap(GRAY); print -dpng fig/test2.png
... not good, too much edge ...

% googling ... 
figure(1); image(x,'CDataMapping','scaled'); colormap(GRAY); caxis([0 1]); axis image;
  %set(gca,'position',[0 0 1 1],'units','normalized')
  %iptsetpref('ImshowBorder','tight'); 
  print -dpng fig/test1.png
figure(2); image(x,'CDataMapping','scaled'); colormap(BLUERED); caxis([-1 1]); axis image
  iptsetpref('ImshowBorder','tight'); print -dpng fig/test2.png

% no! downloading freezeCOlors ... 
subplot(121); imshow(x,[-1 1]); colormap(BLUERED); freezeColors; 
subplot(122); imshow(x,[-1 1]); colormap(gray); 
% wow, works ! using plain image is better for printing though .... 


  








 



subplot(122); imagesc(x); colormap(gray); axis image; axis off



+++++++++++++= old one smazat  ++++++++++


x = imread('fig/lena_cb.tif'); 
subplot(121); imagesc(x); colormap(gray); axis image; axis off
subplot(122); imagesc(x); colormap(gray); axis image; axis off
print -deps -loose FIG/ll.eps
% nee, je lepsi tisknout po jednom !
imagesc(x); colormap(gray); axis image; axis off
print -deps -loose FIG/ll.eps


% hratky s frekvencemi:
% black 
x = zeros(256,256); imagesc(x); axis image; axis off
print -deps -loose FIG/black.eps
X = fft2(x); m=0:9; n=0:9; imagesc(m,n,X(m+1,n+1)); axis image; 
print -deps -loose FIG/Sblack.eps

% white 
x = ones(256,256); image(64*x); axis image; axis off
print -deps -loose FIG/white.eps
X = fft2(x); m=0:9; n=0:9; imagesc(m,n,X(m+1,n+1)); axis image; 
print -deps -loose FIG/Swhite.eps

% ted kosiny
k = repmat((0:255)',1,256); l = repmat((0:255),256,1);
K = 256; L = 256; M=256; N=256; 

% kos vodorovne - druha odmocnina je lepsi nez log ... 
n = 0:255; N = 256; f=1/N;
x = 1/2+1/2*cos(2*pi*f*l); imagesc(z);axis image; axis off
print -deps -loose FIG/f1.eps
X = fft2(x); m=0:9; n=0:9; imagesc(m,n,sqrt(abs(X(m+1,n+1)))); axis image; 
print -deps -loose FIG/Sf1.eps

% jeste jeden 
n = 0:255; N = 256; f=2/N;
x = 1/2+1/2*cos(2*pi*f*l); imagesc(x);axis image; axis off
print -deps -loose FIG/f2.eps
X = fft2(x); m=0:9; n=0:9; imagesc(m,n,sqrt(abs(X(m+1,n+1)))); axis image; 
print -deps -loose FIG/Sf2.eps

%%% ted kos svisle:
%  druha odmocnina je lepsi nez log ... 
n = 0:255; N = 256; g=1/N;
x = 1/2+1/2*cos(2*pi*g*k); imagesc(x);axis image; axis off
print -deps -loose FIG/g1.eps
X = fft2(x); m=0:9; n=0:9; imagesc(m,n,sqrt(abs(X(m+1,n+1)))); axis image; 
print -deps -loose FIG/Sg1.eps
  
% jeste s 4-nas frekv:  druha odmocnina je lepsi nez log ... 
n = 0:255; N = 256; g=4/N;
x = 1/2+1/2*cos(2*pi*g*k); imagesc(x);axis image; axis off
print -deps -loose FIG/g4.eps
X = fft2(x); m=0:9; n=0:9; imagesc(m,n,sqrt(abs(X(m+1,n+1)))); axis image; 
print -deps -loose FIG/Sg4.eps
  

% co takhle obdelnik ? 
x = zeros(256,256); x(1:256,65:192) = 1;
imagesc(x);axis image; axis off
print -deps -loose FIG/obd.eps
X = fft2(x); m=0:9; n=0:9; imagesc(m,n,sqrt(abs(X(m+1,n+1)))); axis image; 
print -deps -loose FIG/Sobd.eps

% a ctverec !!!  - tady to chvce log !
x = zeros(256,256); x(65:192,65:192) = 1;
imagesc(x);axis image; axis off
print -deps -loose FIG/ctverec.eps
X = fft2(x); m=0:9; n=0:9; imagesc(m,n,log(abs(X(m+1,n+1)))); axis image; 
print -deps -loose FIG/Sctverec.eps

%%%%%%%% lena  - spec 
x = imread('FIG/lena_cb.tif'); z = double(x)/256;
imagesc(x); colormap(gray); axis image; axis off
%print -deps -loose FIG/orig.eps
X = fft2(x); m=0:127; n=0:127; imagesc(m,n,log(abs(X(m+1,n+1)))); axis image; 
print -deps -loose FIG/Slena.eps

%%%%%%%%%


%%%%%%%%% filtrovani Lena - DP, pak HP
x = imread('FIG/lena_cb.tif'); z = double(x)/256;
imagesc(x); colormap(gray); axis image; axis off
print -deps -loose FIG/orig.eps

zn = z+0.1*randn(512,512); 
imagesc(zn); colormap(gray); axis image; axis off
print -deps -loose FIG/noise.eps

% DP - musim vzit matici 10x10, jinak to neni videt ... 
m = ones(10,10); %[1 1 1; 1 1 1; 1 1 1];
dp = filter2(m,zn); 
imagesc(dp); colormap(gray); axis image; axis off
print -deps -loose FIG/dp.eps

% HP - ten podle Pavla... hm hm, moc se mi nelibi ... 
m =[0 -1 0; -1 5 -1; 0 -1 0];
hp = filter2(m,z); 
imagesc(hp); colormap(gray); axis image; axis off
print -deps -loose FIG/hp.eps

% det. vert contours 
m =[1 0 -1; 2 0 -2; 1 0 -1];
hpvert = filter2(m,z); vis = abs(hpvert); 
imagesc(log(vis+1)); colormap(gray); axis image; axis off
print -deps -loose FIG/hpvert.eps

% det. hor contours 
m =[1 0 -1; 2 0 -2; 1 0 -1]';
hphor = filter2(m,z); vis = abs(hphor); 
imagesc(log(vis+1)); colormap(gray); axis image; axis off
print -deps -loose FIG/hphor.eps

% oba dohromady ...
cont = abs(hphor) + abs(hpvert); 
imagesc(log(cont+1)); colormap(gray); axis image; axis off
print -deps -loose FIG/horvert.eps


% medianovy 10x10 ... zatim nee ... 

med = medfilt2(zn,[5 5]); 
imagesc(med); colormap(gray); axis image; axis off
print -deps -loose FIG/med.eps

%%%%%%% kvantovani %%%%%%
x = imread('FIG/lena_cb.tif'); z = double(x)/256;
imagesc(x); colormap(gray); axis image; axis off

zq = round(z * 4) / 4; 
imagesc(zq); colormap(gray); axis image; axis off
print -deps -loose FIG/quant.eps

